#! /usr/bin/env python

import sys, os
from browser_stack import get_stack, save_stack

command = sys.argv[1]
if command.startswith('--'):
    command = command[2:]

stack = get_stack()

if command in ('get', 'peek', 'print'):
    if stack: print stack[0],
    sys.exit()
elif command in ('list', 'list-all'):
    if stack: print ''.join(stack),
    sys.exit()

browser = os.path.basename(sys.argv[2]) + '\n'
if browser in stack:
    # With 'push' this prevents duplicates
    stack.remove(browser)

if command == 'push':
    stack.insert(0, browser)
elif command == 'pop':
    pass # The browser was already removed
else:
    raise ValueError('Unknown command "%s"' % command)

save_stack(stack)
